| CUTLASS CUDA Templates for Linear Algebra Subroutines and Solvers

- Main Page
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Static Public Member Functions | Static Public Attributes | List of all members
cutlass::layout::ColumnMajor Class Reference

Mapping function for column-major matrices.

`#include <matrix.h>`

## Public Types
using | Index = int32_t
| Index type used for coordinates. More...
using | LongIndex = int64_t
| Long index type used for offsets. More...
using | TensorCoord = MatrixCoord
| Logical coordinate. More...
using | Stride = Coord< kStrideRank, Index >
| Stride vector. More...

## Public Member Functions
CUTLASS_HOST_DEVICE | ColumnMajor (Index ldm=0)
| Ctor. More...
CUTLASS_HOST_DEVICE | ColumnMajor (Stride stride)
| Ctor. More...
CUTLASS_HOST_DEVICE LongIndex | operator() (MatrixCoord const &coord) const
CUTLASS_HOST_DEVICE MatrixCoord | inverse (LongIndex offset) const
| Inverse of layout function, mapping linear offset to logical coordinate. More...
CUTLASS_HOST_DEVICE Stride | stride () const
| Returns the stride of the layout. More...
CUTLASS_HOST_DEVICE Stride & | stride ()
| Returns the stride of the layout. More...
CUTLASS_HOST_DEVICE Index | stride (int idx) const
| Returns the stride of the layout. More...
CUTLASS_HOST_DEVICE Index & | stride (int idx)
| Returns the stride of the layout. More...
CUTLASS_HOST_DEVICE LongIndex | capacity (MatrixCoord const &extent) const
| Compute the number of contiguous elements needed to store a tensor with the given size. More...

## Static Public Member Functions
static CUTLASS_HOST_DEVICE ColumnMajor | packed (MatrixCoord const &extent)
| Helper returns a layout to a tightly packed tensor. More...

## Static Public Attributes
static int const | kRank = 2
| Logical rank of tensor. More...
static int const | kStrideRank = 1
| Rank of stride vector. More...

## Member Typedef Documentation

using cutlass::layout::ColumnMajor::Index = int32_t

using cutlass::layout::ColumnMajor::LongIndex = int64_t

using cutlass::layout::ColumnMajor::Stride = Coord<kStrideRank, Index>

using cutlass::layout::ColumnMajor::TensorCoord = MatrixCoord

## Constructor & Destructor Documentation

CUTLASS_HOST_DEVICE cutlass::layout::ColumnMajor::ColumnMajor | ( | Index | ldm = `0` | ) |
| inline

CUTLASS_HOST_DEVICE cutlass::layout::ColumnMajor::ColumnMajor | ( | Stride | stride | ) |
| inline

## Member Function Documentation

CUTLASS_HOST_DEVICE LongIndex cutlass::layout::ColumnMajor::capacity | ( | MatrixCoord const & | extent | ) | const
| inline

CUTLASS_HOST_DEVICE MatrixCoord cutlass::layout::ColumnMajor::inverse | ( | LongIndex | offset | ) | const
| inline

CUTLASS_HOST_DEVICE LongIndex cutlass::layout::ColumnMajor::operator() | ( | MatrixCoord const & | coord | ) | const
| inline

Returns the offset of a coordinate in linear memory. Assumes coordinate has convention (row, column)

static CUTLASS_HOST_DEVICE ColumnMajor cutlass::layout::ColumnMajor::packed | ( | MatrixCoord const & | extent | ) |
| inline static

CUTLASS_HOST_DEVICE Stride cutlass::layout::ColumnMajor::stride | ( |  | ) | const
| inline

CUTLASS_HOST_DEVICE Stride& cutlass::layout::ColumnMajor::stride | ( |  | ) |
| inline

CUTLASS_HOST_DEVICE Index cutlass::layout::ColumnMajor::stride | ( | int | idx | ) | const
| inline

CUTLASS_HOST_DEVICE Index& cutlass::layout::ColumnMajor::stride | ( | int | idx | ) |
| inline

## Member Data Documentation

int const cutlass::layout::ColumnMajor::kRank = 2
| static

int const cutlass::layout::ColumnMajor::kStrideRank = 1
| static

The documentation for this class was generated from the following file:

- layout/matrix.h